/* recognize tokens for the calculator and print them out */
%{
enum yytokentype {
	NUMBER = 258,
	ADD = 259,
	SUB = 260,
	MUL = 261,
	DIV = 262,
	OP  = 264,
	CP	= 265,
	EOL = 264
};
int yylval;
%}

%%
"+" { return ADD; }
"-" { return SUB; }
"*" { return MUL; }
"/" { return DIV; }
"(" { return OP; }
")" { return CP; }
[0-9]+ { yylval = atoi(yytext); return NUMBER; }
\n { return EOL; }
[ \t] { /* ignore whitespace */ }
. { printf("Mystery character %c\n", *yytext); }
%%

int yywrap()
{
	return 1;
}

main(int argc, char **argv)
{
	int tok;
	++argv; --argc; /* skip over program name */
	if ( argc > 0 ) yyin = fopen( argv[0], "r" );
	else yyin = stdin;
	
	while(tok = yylex()) 
	{
		printf("%d", tok);
		if(tok == NUMBER) printf(" = %d\n", yylval);
		else printf("\n");
	}
}